require "import"
import "java.text.SimpleDateFormat"
import "java.util.Date"
import "android.content.Context"
import "android.content.Intent"
import "android.content.IntentFilter"
import "android.os.BatteryManager"

function speakDateTime(context)
    local currentDate = os.date("%A, %B %d, %Y")
    local formattedTime = SimpleDateFormat("hh:mm a").format(Date())

    local batteryIntent = context.registerReceiver(nil, IntentFilter(Intent.ACTION_BATTERY_CHANGED))
    local level = batteryIntent.getIntExtra(BatteryManager.EXTRA_LEVEL, -1)
    local scale = batteryIntent.getIntExtra(BatteryManager.EXTRA_SCALE, -1)
    local batteryPercent = math.floor((level / scale) * 100)

    -- Speak the message
    local message = "Today is " .. currentDate .. ". The time is " .. formattedTime .. ". The battery level is " .. batteryPercent .. " percent."
    context.speak(message)
end

speakDateTime(this)

return true